Bug 485182 - Data cards like Huawei EC121 does not work with RHEL5
Data cards like Huawei EC121 does not work with RHEL5
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
5.3
All Linux
low Severity medium
: rc
: ---
Assigned To: Pete Zaitcev
Red Hat Kernel QE team
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-02-12 01:01 EST by Huzaifa S. Sidhpurwala
Modified: 2009-09-02 05:03 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-09-02 05:03:09 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
patch to make huawei cards work (12.14 KB, patch)
2009-04-09 03:30 EDT, Huzaifa S. Sidhpurwala
no flags Details | Diff
Test patch - re-indented, ID tables merged (11.15 KB, patch)
2009-04-28 20:45 EDT, Pete Zaitcev
no flags Details | Diff

  None (edit)
Description Huzaifa S. Sidhpurwala 2009-02-12 01:01:09 EST
Description of problem:
Modern day datacards like the above have a small flash chip which contain windoze drivers. You need to toggle the device to get the kernel to recognize GSM modem.

Version-Release number of selected component (if applicable):
latest RHEL 5.3 with all errata etc

How reproducible:
Insert device, kernel shows USB CDROM,
no GSM model even when using usb_modeswitch

Note:
Works out of box in F9 and above.
Comment 1 Dan Williams 2009-02-15 09:03:26 EST
I've been working on a cleaner method to do this in udev-extras.  There are a few problems with usb_modeswitch; it's pretty nasty code, and basically gives users carte-blanche (if you can edit the config file) to send whatever strings they like to the USB device.  The ideal case (and what I've been doing in udev-extras) is to classify the "CD-ROM Kill" method and use that in the udev rules instead of having a huge config file for every modem like usb_modeswitch.

Huawei also posted unusual-devs patches that kill their driver CD a few months ago.
Comment 2 Pete Zaitcev 2009-03-09 10:02:52 EDT
WOuld someone please attach /proc/bus/usb/devices from the problem device?
I have no idea what you guys are talking about.
Comment 3 Dan Williams 2009-03-09 16:37:43 EDT
(In reply to comment #2)
> WOuld someone please attach /proc/bus/usb/devices from the problem device?
> I have no idea what you guys are talking about.  

First problem is that the device IDs are most likely not present in drivers/usb/serial/option.c.

The second issue is the patch that the Huawei people sent to automatically kill their "driver CD" device and bring the modem up in multi-port mode:

1460e5e44cc5ecad7704f63b10dcb3a59d0e008b
aad8a278f37e748bfe310a1366f2aa7e0dbaf365
d853d872c14b9adc4adad29e56cd378b291f86e0
Comment 5 Huzaifa S. Sidhpurwala 2009-04-09 03:30:22 EDT
Created attachment 338871 [details]
patch to make huawei cards work
Comment 6 Huzaifa S. Sidhpurwala 2009-04-09 03:31:19 EDT
Attached patch on 2.6.18-128 kernel makes the huawei cards work well.
Comment 8 Huzaifa S. Sidhpurwala 2009-04-15 12:15:12 EDT
Can some one look at my patch and let me know if they are ok?
Comment 10 Dan Williams 2009-04-22 13:16:00 EDT
See also https://bugzilla.redhat.com/show_bug.cgi?id=496426 for the NM side of the EC121.  I would like to harm the Huawei firmware engineers quite painfully.
Comment 12 Huzaifa S. Sidhpurwala 2009-04-27 00:05:34 EDT
Yes, i have the available hardware to test it for 5.4 beta.
Comment 13 Pete Zaitcev 2009-04-28 10:31:36 EDT
The patch looks good to me. I'm going to merge the ID tables since the
driver does not have separate subdrivers.

By the way, this patch should be sufficient to work without usb_switch.
Please let me know if this is not the case (if you still need that awful
program with the patch applied).

See bug 253096 for minimum necessary firmware revisions.
Comment 14 Pete Zaitcev 2009-04-28 20:45:07 EDT
Created attachment 341678 [details]
Test patch - re-indented, ID tables merged
Comment 15 Pete Zaitcev 2009-04-28 20:47:01 EDT
Huzaifa, please test the kernel 2.6.18-141.el5.bz485182.1 from here:
 http://people.redhat.com/zaitcev/ftp/485182/
With quick turnaround we may be able to make the beta.
Comment 17 Huzaifa S. Sidhpurwala 2009-04-28 23:35:54 EDT
After testing:
After connecting to the usb, i see the connect/disconnect dance as mentioned in 
https://bugzilla.redhat.com/show_bug.cgi?id=253096

My solution for this is to do a rmmod usb-storage a couple of times and it works.

Since the soln is to upgrade the device firmware and has nothing to do with the kernel, i guess the kernel is fine.

I will call this test a pass :)
Comment 19 Don Zickus 2009-05-12 13:41:16 EDT
in kernel-2.6.18-146.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5

Please do NOT transition this bugzilla state to VERIFIED until our QE team
has sent specific instructions indicating when to do so.  However feel free
to provide a comment indicating that this fix has been verified.
Comment 22 errata-xmlrpc 2009-09-02 05:03:09 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-1243.html

Note You need to log in before you can comment on or make changes to this bug.